Index: cpukit/libfs/src/dosfs/msdos_misc.c
===================================================================
RCS file: /usr1/CVS/rtems/cpukit/libfs/src/dosfs/msdos_misc.c,v
retrieving revision 1.14
diff -p -u -u -r1.14 msdos_misc.c
--- cpukit/libfs/src/dosfs/msdos_misc.c	4 Sep 2008 08:33:06 -0000	1.14
+++ cpukit/libfs/src/dosfs/msdos_misc.c	23 Apr 2009 07:54:40 -0000
@@ -18,6 +18,7 @@
 #endif
 
 #include <stdlib.h>
+#include <ctype.h>
 #include <sys/time.h>
 #include <unistd.h>
 #include <string.h>
@@ -30,6 +31,212 @@
 
 #include "msdos.h"
 
+
+#include <stdio.h>
+
+/*
+ * External strings. Saves spave this way.
+ */
+const char const* MSDOS_DOT_NAME    = ".          ";
+const char const* MSDOS_DOTDOT_NAME = "..         ";
+
+/* msdos_is_valid_name_char --
+ *     Routine to check the character in a file or directory name.
+ *     The characters support in the short file name are letters,
+ *     digits, or characters with code points values greater than
+ *     127 (not sure what this last is) plus the following special
+ *     characters "$%'-_@~`!(){}^#&". The must be uppercase.
+ *
+ *     The following 6 characters are allowed in a long names,
+ *     " +,;=[]" including a space and lower case letters.
+ *
+ * PARAMETERS:
+ *     ch        - character to check.
+ *
+ * RETURNS:
+ *     MSDOS_NAME_INVALID - Not valid in a long or short name.
+ *     MSDOS_NAME_SHORT   - Valid in a short name or long name.
+ *     MSDOS_NAME_LONG    - Valid in a long name only.
+ *
+ */
+static msdos_name_type_t
+msdos_is_valid_name_char(const char ch)
+{
+    if (strchr(" +,;=[]", ch) != NULL)
+        return MSDOS_NAME_LONG;
+
+    if ((ch == '.') || isalnum(ch) ||
+        (strchr("$%'-_@~`!(){}^#&", ch) != NULL))
+        return MSDOS_NAME_SHORT;
+    
+    return MSDOS_NAME_INVALID;
+}
+
+/* msdos_short_hex_number --
+ *     Routine to set the hex number in the SFN.
+ *
+ * PARAMETERS:
+ *     name      - name to change
+ *     num       - number to set
+ *
+ * RETURNS:
+ *     nothing
+ *
+ */
+static void
+msdos_short_name_hex(char* sfn, int num)
+{
+    static const char* hex = "0123456789ABCDEF";
+    char* c = MSDOS_DIR_NAME(sfn) + 3;
+    int   i;   
+    *c++ = '~';
+    for (i = 0; i < 4; i++, c++)
+      *c = hex[(num >> ((3 - i) * 4)) & 0xf];
+}
+
+/* msdos_short_random_name --
+ *     Routine to creates a random short name by changing the last 4 characters
+ *     of the name to hex digits based on the number of ticks and the checksum
+ *     short name. The checksum of the short name lets the name be different
+ *     called more than once in a single tick.
+ *
+ * PARAMETERS:
+ *     name      - name to change
+ *
+ * RETURNS:
+ *     nothing
+ *
+ */
+static void
+msdos_short_random_name(char* sfn)
+{
+    uint32_t ticks = rtems_clock_get_ticks_since_boot();
+    uint8_t* p = (uint8_t*) MSDOS_DIR_NAME(sfn);
+    uint16_t cs = 0;
+    int      i;
+    for (i = 0; i < 11; i++, p++)
+        cs = ((cs & 1) ? 0x80 : 0) + (cs >> 1) + *p;
+    ticks += cs << 8;
+    msdos_short_name_hex(sfn, ticks);
+}
+
+/* msdos_name_type --
+ *     Routine the type of file name.
+ *
+ * PARAMETERS:
+ *     name      - name to check
+ *
+ * RETURNS:
+ *     true the name is long, else the name is short.
+ *
+ */
+static msdos_name_type_t
+msdos_name_type(const char *name, int name_len)
+{
+    bool dot = false;
+    bool lowercase = false;
+    bool uppercase = false;
+    int  dot_at = 0;
+    int  count = 0;
+
+    while (*name && (count < name_len))
+    {
+        msdos_name_type_t type = msdos_is_valid_name_char(*name);
+
+        if ((type == MSDOS_NAME_INVALID) || (type == MSDOS_NAME_LONG))
+            return type;
+
+        if (dot)
+        {
+            if ((*name == '.') || ((count - dot_at) > 3))
+                return MSDOS_NAME_LONG;
+        }
+        else
+        {
+            if (count >= 8)
+                return MSDOS_NAME_LONG;
+        }
+
+        if (*name == '.')
+        {
+            dot = true;
+            dot_at = count;
+        }
+        else if ((*name >= 'A') && (*name <= 'Z'))
+            uppercase = true;
+        else if ((*name >= 'a') && (*name <= 'z'))
+            lowercase = true;
+        
+        count++;
+        name++;
+    }
+
+    if (lowercase && uppercase)
+        return MSDOS_NAME_LONG;
+    
+    return MSDOS_NAME_SHORT;
+}
+
+/* msdos_long_to_short --
+ *     Routine to creates a short name from a long. Start the end of the 
+ *
+ * PARAMETERS:
+ *     name      - name to check
+ *
+ * RETURNS:
+ *     true the name is long, else the name is short.
+ *
+ */
+msdos_name_type_t
+msdos_long_to_short(const char *lfn, int lfn_len, char* sfn, int sfn_len)
+{
+    msdos_name_type_t type;
+    int               i;
+
+    /*
+     * Fill with spaces. This is how a short directory entry is padded.
+     */
+    memset (sfn, ' ', sfn_len);
+
+    /*
+     * Handle '.' and '..' specially.
+     */
+    if ((lfn[0] == '.') && (lfn_len == 1))
+    {
+        sfn[0] = '.';
+        return MSDOS_NAME_SHORT;
+    }
+        
+    if ((lfn[0] == '.') && (lfn[1] == '.') && (lfn_len == 2))
+    {
+        sfn[0] = sfn[1] = '.';
+        return MSDOS_NAME_SHORT;
+    }
+
+    /*
+     * Filenames with only blanks and dots are not allowed!
+     */
+    for (i = 0; i < lfn_len; i++)
+        if ((lfn[i] != ' ') && (lfn[i] == '.'))
+            break;
+
+    if (i > lfn_len)
+        return MSDOS_NAME_INVALID;
+
+    /*
+     * Is this a short name ?
+     */
+    
+    type = msdos_name_type (lfn, lfn_len);
+
+    if (type == MSDOS_NAME_INVALID)
+        return MSDOS_NAME_INVALID;
+    
+    msdos_filename_unix2dos (lfn, lfn_len, sfn);
+    
+    return type;
+}
+
 /* msdos_get_token --
  *     Routine to get a token (name or separator) from the path.
  *
@@ -43,35 +250,34 @@
  *
  */
 msdos_token_types_t
-msdos_get_token(const char *path, char *ret_token, int *token_len)
+msdos_get_token(const char *path, const char **ret_token, int *ret_token_len)
 {
-    int                 rc = RC_OK;
-    register int        i = 0;
     msdos_token_types_t type = MSDOS_NAME;
-    char                token[MSDOS_NAME_MAX_WITH_DOT+1];
-    register char       c;
+    int                 i = 0;
+
+    *ret_token = NULL;
+    *ret_token_len = 0;
 
     /*
-     *  Copy a name into token.  (Remember NULL is a token.)
+     *  Check for a separator.
      */
-    c = path[i];
-    while ( (!msdos_is_separator(c)) && (i <= MSDOS_NAME_MAX_WITH_DOT) )
+    while (!msdos_is_separator(path[i]))
     {
-        token[i] = c;
-        if ( i == MSDOS_NAME_MAX_WITH_DOT )
+        if ( !msdos_is_valid_name_char(path[i]) )
             return MSDOS_INVALID_TOKEN;
-        if ( !msdos_is_valid_name_char(c) )
+        ++i;
+        if ( i == MSDOS_NAME_MAX_LFN_WITH_DOT )
             return MSDOS_INVALID_TOKEN;
-        c = path [++i];
     }
 
+    *ret_token = path;
+    
     /*
-     *  Copy a seperator into token.
+     *  If it is just a separator then it is the current dir.
      */
     if ( i == 0 )
     {
-        token[i] = c;
-        if ( token[i] != '\0' )
+        if ( *path != '\0' )
         {
             i++;
             type = MSDOS_CURRENT_DIR;
@@ -79,13 +285,11 @@ msdos_get_token(const char *path, char *
         else
             type = MSDOS_NO_MORE_PATH;
     }
-    else if (token[ i-1 ] != '\0')
-        token[i] = '\0';
 
     /*
-     *  Set token_len to the number of characters copied.
+     *  Set the token and token_len to the token start and length.
      */
-    *token_len = i;
+    *ret_token_len = i;
 
     /*
      *  If we copied something that was not a seperator see if
@@ -93,25 +297,19 @@ msdos_get_token(const char *path, char *
      */
     if ( type == MSDOS_NAME )
     {
-        if ( strcmp( token, "..") == 0 )
+        if ((i == 2) && ((*ret_token)[0] == '.') && ((*ret_token)[1] == '.'))
         {
-            strcpy(ret_token, MSDOS_DOTDOT_NAME);
             type = MSDOS_UP_DIR;
             return type;
         }
 
-        if ( strcmp( token, "." ) == 0 )
+        if ((i == 1) && ((*ret_token)[0] == '.'))
         {
-            strcpy(ret_token, MSDOS_DOT_NAME);
             type = MSDOS_CURRENT_DIR;
             return type;
         }
-
-        rc = msdos_filename_unix2dos(token, *token_len, ret_token);
-        if ( rc != RC_OK )
-            return MSDOS_INVALID_TOKEN;
     }
-    ret_token[MSDOS_NAME_MAX] = '\0';
+
     return type;
 }
 
@@ -133,50 +331,61 @@ msdos_get_token(const char *path, char *
 int
 msdos_find_name(
     rtems_filesystem_location_info_t *parent_loc,
-    char                             *name
+    const char                       *name,
+    int                               name_len
     )
 {
-    int              rc = RC_OK;
-    msdos_fs_info_t *fs_info = parent_loc->mt_entry->fs_info;
-    fat_file_fd_t   *fat_fd = NULL;
-    fat_auxiliary_t  aux;
-    unsigned short   time_val = 0;
-    unsigned short   date = 0;
-    char             node_entry[MSDOS_DIRECTORY_ENTRY_STRUCT_SIZE];
+    int                rc = RC_OK;
+    msdos_fs_info_t   *fs_info = parent_loc->mt_entry->fs_info;
+    fat_file_fd_t     *fat_fd = NULL;
+    msdos_name_type_t  name_type;
+    fat_dir_pos_t      dir_pos;
+    unsigned short     time_val = 0;
+    unsigned short     date = 0;
+    char               node_entry[MSDOS_DIRECTORY_ENTRY_STRUCT_SIZE];
 
     memset(node_entry, 0, MSDOS_DIRECTORY_ENTRY_STRUCT_SIZE);
 
+    name_type = msdos_long_to_short (name,
+                                     name_len,
+                                     MSDOS_DIR_NAME(node_entry),
+                                     MSDOS_NAME_MAX);
+
     /*
      * find the node which correspondes to the name in the directory pointed by
      * 'parent_loc'
      */
-    rc = msdos_get_name_node(parent_loc, name, &aux, node_entry);
+    rc = msdos_get_name_node(parent_loc, false, name, name_len, name_type,
+                             &dir_pos, node_entry);
     if (rc != RC_OK)
         return rc;
 
+    if (((*MSDOS_DIR_ATTR(node_entry)) & MSDOS_ATTR_VOLUME_ID) ||
+        ((*MSDOS_DIR_ATTR(node_entry) & MSDOS_ATTR_LFN_MASK) == MSDOS_ATTR_LFN))
+        return MSDOS_NAME_NOT_FOUND_ERR;
+
     /* open fat-file corresponded to the found node */
-    rc = fat_file_open(parent_loc->mt_entry, aux.cln, aux.ofs, &fat_fd);
+    rc = fat_file_open(parent_loc->mt_entry, &dir_pos, &fat_fd);
     if (rc != RC_OK)
         return rc;
 
+    fat_fd->dir_pos = dir_pos;
+    
     /*
-     * I don't like this if, but: we should do it , or should write new file
+     * I don't like this if, but: we should do it, or should write new file
      * size and first cluster num to the disk after each write operation
-     * (even if one byte is written  - that is TOO non-optimize) because
+     * (even if one byte is written  - that is TOO slow) because
      * otherwise real values of these fields stored in fat-file descriptor
-     * may be accidentely rewritten with wrong values stored on the disk
+     * may be accidentally rewritten with wrong values stored on the disk
      */
     if (fat_fd->links_num == 1)
     {
-        fat_fd->info_cln = aux.cln;
-        fat_fd->info_ofs = aux.ofs;
         fat_fd->cln = MSDOS_EXTRACT_CLUSTER_NUM(node_entry);
-        fat_fd->first_char = *MSDOS_DIR_NAME(node_entry);
 
         time_val = *MSDOS_DIR_WRITE_TIME(node_entry);
         date = *MSDOS_DIR_WRITE_DATE(node_entry);
 
-        fat_fd->mtime = msdos_date_dos2unix(CF_LE_W(time_val), CF_LE_W(date));
+        fat_fd->mtime = msdos_date_dos2unix(CF_LE_W(date), CF_LE_W(time_val));
 
         if ((*MSDOS_DIR_ATTR(node_entry)) & MSDOS_ATTR_DIRECTORY)
         {
@@ -227,7 +436,7 @@ msdos_find_name(
 }
 
 /* msdos_get_name_node --
- *     This routine is used in two ways: for a new mode creation (a) or for
+ *     This routine is used in two ways: for a new node creation (a) or for
  *     search the node which correspondes to the name parameter (b).
  *     In case (a) 'name' should be set up to NULL and 'name_dir_entry' should
  *     point to initialized 32 bytes structure described a new node.
@@ -247,7 +456,7 @@ msdos_find_name(
  *     name           - NULL or name to find
  *     paux           - identify a node location on the disk -
  *                      cluster num and offset inside the cluster
- *     name_dir_entry - node to create/placeholder for found node (IN/OUT)
+ *     short_dir_entry - node to create/placeholder for found node (IN/OUT)
  *
  * RETURNS:
  *     RC_OK, filled aux_struct_ptr and name_dir_entry on success, or -1 if
@@ -257,90 +466,63 @@ msdos_find_name(
 int
 msdos_get_name_node(
     rtems_filesystem_location_info_t *parent_loc,
-    char                             *name,
-    fat_auxiliary_t                  *paux,
+    bool                              create_node,
+    const char                       *name,
+    int                               name_len,
+    msdos_name_type_t                 name_type,
+    fat_dir_pos_t                    *dir_pos,
     char                             *name_dir_entry
     )
 {
     int              rc = RC_OK;
-    ssize_t          ret = 0;
-    msdos_fs_info_t *fs_info = parent_loc->mt_entry->fs_info;
     fat_file_fd_t   *fat_fd = parent_loc->node_access;
     uint32_t         dotdot_cln = 0;
 
-    /* find name in fat-file which correspondes to the directory */
-    rc = msdos_find_name_in_fat_file(parent_loc->mt_entry, fat_fd, name, paux,
-                                     name_dir_entry);
+    /* find name in fat-file which corresponds to the directory */
+    rc = msdos_find_name_in_fat_file(parent_loc->mt_entry, fat_fd,
+                                     create_node, name, name_len, name_type,
+                                     dir_pos, name_dir_entry);
     if ((rc != RC_OK) && (rc != MSDOS_NAME_NOT_FOUND_ERR))
         return rc;
 
-    /* if we search for valid name and name not found -> return */
-    if ((rc == MSDOS_NAME_NOT_FOUND_ERR) && (name != NULL))
-        return rc;
-
-    /*
-     * if we try to create new entry and the directory is not big enough
-     * currently - try to enlarge directory
-     */
-    if ((rc == MSDOS_NAME_NOT_FOUND_ERR) && (name == NULL))
+    if (!create_node)
     {
-        ret = fat_file_write(parent_loc->mt_entry, fat_fd,
-                             fat_fd->fat_file_size,
-                             MSDOS_DIRECTORY_ENTRY_STRUCT_SIZE,
-                             (uint8_t *)name_dir_entry);
-        if (ret == -1)
-            return -1;
-
-        /* on success directory is enlarged by a new cluster */
-        fat_fd->fat_file_size += fs_info->fat.vol.bpc;
-
-        /* get cluster num where a new node located */
-        rc = fat_file_ioctl(parent_loc->mt_entry, fat_fd, F_CLU_NUM,
-                            fat_fd->fat_file_size - 1, &paux->cln);
-
-        if (rc != RC_OK)
+        /* if we search for valid name and name not found -> return */
+        if (rc == MSDOS_NAME_NOT_FOUND_ERR)
             return rc;
 
         /*
-         * if new cluster allocated succesfully then new node is at very
-         * beginning of the cluster (offset is computed in bytes)
+         * if we have deal with ".." - it is a special case :(((
+         *
+         * Really, we should return cluster num and offset not of ".." slot, but
+         * slot which correspondes to real directory name.
          */
-        paux->ofs = 0;
-        return RC_OK;
-    }
-
-    /*
-     * if we have deal with ".." - it is a special case :(((
-     *
-     * Really, we should return cluster num and offset not of ".." slot, but
-     * slot which correspondes to real directory name.
-     */
-    if ((rc == RC_OK) && (name != NULL))
-    {
-        if (strncmp(name, MSDOS_DOTDOT_NAME, MSDOS_SHORT_NAME_LEN) == 0)
+        if (rc == RC_OK)
         {
-            dotdot_cln = MSDOS_EXTRACT_CLUSTER_NUM((name_dir_entry));
-
-            /* are we right under root dir ? */
-            if (dotdot_cln == 0)
+            if (strncmp(name, "..", 2) == 0)
             {
-                /*
-                 * we can relax about first_char field - it never should be
-                 * used for root dir
-                 */
-                paux->cln = FAT_ROOTDIR_CLUSTER_NUM;
-                paux->ofs = 0;
-            }
-            else
-            {
-                rc = msdos_get_dotdot_dir_info_cluster_num_and_offset(
-                        parent_loc->mt_entry,
-                        dotdot_cln,
-                        paux,
-                        name_dir_entry
-                        );
-                if (rc != RC_OK)
-                    return rc;
+                dotdot_cln = MSDOS_EXTRACT_CLUSTER_NUM((name_dir_entry));
+
+                /* are we right under root dir ? */
+                if (dotdot_cln == 0)
+                {
+                    /*
+                     * we can relax about first_char field - it never should be
+                     * used for root dir
+                     */
+                    fat_dir_pos_init(dir_pos);
+                    dir_pos->sname.cln = FAT_ROOTDIR_CLUSTER_NUM;
+                }
+                else
+                {
+                    rc =
+                        msdos_get_dotdot_dir_info_cluster_num_and_offset(parent_loc->mt_entry,
+                                                                         dotdot_cln,
+                                                                         dir_pos,
+                                                                         name_dir_entry);
+                    if (rc != RC_OK)
+                        return rc;
+                }
             }
         }
     }
@@ -380,7 +562,7 @@ int
 msdos_get_dotdot_dir_info_cluster_num_and_offset(
     rtems_filesystem_mount_table_entry_t *mt_entry,
     uint32_t                              cln,
-    fat_auxiliary_t                      *paux,
+    fat_dir_pos_t                        *dir_pos,
     char                                 *dir_entry
     )
 {
@@ -391,18 +573,13 @@ msdos_get_dotdot_dir_info_cluster_num_an
     char             dotdot_node[MSDOS_DIRECTORY_ENTRY_STRUCT_SIZE];
     uint32_t         cl4find = 0;
 
-    memset(dot_node, 0, MSDOS_DIRECTORY_ENTRY_STRUCT_SIZE);
-    memset(dotdot_node, 0, MSDOS_DIRECTORY_ENTRY_STRUCT_SIZE);
-
     /*
      * open fat-file corresponded to ".."
      */
-    rc = fat_file_open(mt_entry, paux->cln, paux->ofs, &fat_fd);
+    rc = fat_file_open(mt_entry, dir_pos, &fat_fd);
     if (rc != RC_OK)
         return rc;
 
-    fat_fd->info_cln = paux->cln;
-    fat_fd->info_ofs = paux->ofs;
     fat_fd->cln = cln;
     fat_fd->fat_file_type = FAT_DIRECTORY;
     fat_fd->size_limit = MSDOS_MAX_DIR_LENGHT;
@@ -418,8 +595,10 @@ msdos_get_dotdot_dir_info_cluster_num_an
     }
 
     /* find "." node in opened directory */
-    rc = msdos_find_name_in_fat_file(mt_entry, fat_fd, MSDOS_DOT_NAME, paux,
-                                     dot_node);
+    memset(dot_node, 0, MSDOS_DIRECTORY_ENTRY_STRUCT_SIZE);
+    msdos_long_to_short(".", 1, dot_node, MSDOS_SHORT_NAME_LEN);
+    rc = msdos_find_name_in_fat_file(mt_entry, fat_fd, false, ".", 1,
+                                     MSDOS_NAME_SHORT, dir_pos, dot_node);
 
     if (rc != RC_OK)
     {
@@ -428,7 +607,10 @@ msdos_get_dotdot_dir_info_cluster_num_an
     }
 
     /* find ".." node in opened directory */
-    rc = msdos_find_name_in_fat_file(mt_entry, fat_fd, MSDOS_DOTDOT_NAME, paux,
+    memset(dotdot_node, 0, MSDOS_DIRECTORY_ENTRY_STRUCT_SIZE);
+    msdos_long_to_short("..", 2, dotdot_node, MSDOS_SHORT_NAME_LEN);
+    rc = msdos_find_name_in_fat_file(mt_entry, fat_fd, false, "..", 2,
+                                     MSDOS_NAME_SHORT, dir_pos,
                                      dotdot_node);
 
     if (rc != RC_OK)
@@ -450,18 +632,15 @@ msdos_get_dotdot_dir_info_cluster_num_an
          * we handle root dir for all FAT types in the same way with the
          * ordinary directories ( through fat_file_* calls )
          */
-        paux->cln = FAT_ROOTDIR_CLUSTER_NUM;
-        paux->ofs = 0;
+        fat_dir_pos_init(dir_pos);
+        dir_pos->sname.cln = FAT_ROOTDIR_CLUSTER_NUM;
     }
 
     /* open fat-file corresponded to second ".." */
-    rc = fat_file_open(mt_entry, paux->cln, paux->ofs, &fat_fd);
+    rc = fat_file_open(mt_entry, dir_pos, &fat_fd);
     if (rc != RC_OK)
         return rc;
 
-    fat_fd->info_cln = paux->cln;
-    fat_fd->info_ofs = paux->ofs;
-
     if ((MSDOS_EXTRACT_CLUSTER_NUM(dotdot_node)) == 0)
         fat_fd->cln = fs_info->fat.vol.rdir_cl;
     else
@@ -482,7 +661,7 @@ msdos_get_dotdot_dir_info_cluster_num_an
 
     /* in this directory find slot with specified cluster num */
     rc = msdos_find_node_by_cluster_num_in_fat_file(mt_entry, fat_fd, cl4find,
-                                                    paux, dir_entry);
+                                                    dir_pos, dir_entry);
     if (rc != RC_OK)
     {
         fat_file_close(mt_entry, fat_fd);
@@ -518,16 +697,16 @@ msdos_set_dir_wrt_time_and_date(
     uint32_t         sec = 0;
     uint32_t         byte = 0;
 
-    msdos_date_unix2dos(fat_fd->mtime, &time_val, &date);
+    msdos_date_unix2dos(fat_fd->mtime, &date, &time_val);
 
     /*
      * calculate input for _fat_block_write: convert (cluster num, offset) to
      * (sector num, new offset)
      */
-    sec = fat_cluster_num_to_sector_num(mt_entry, fat_fd->info_cln);
-    sec += (fat_fd->info_ofs >> fs_info->fat.vol.sec_log2);
+    sec = fat_cluster_num_to_sector_num(mt_entry, fat_fd->dir_pos.sname.cln);
+    sec += (fat_fd->dir_pos.sname.ofs >> fs_info->fat.vol.sec_log2);
     /* byte points to start of 32bytes structure */
-    byte = fat_fd->info_ofs & (fs_info->fat.vol.bps - 1);
+    byte = fat_fd->dir_pos.sname.ofs & (fs_info->fat.vol.bps - 1);
 
     time_val = CT_LE_W(time_val);
     ret1 = _fat_block_write(mt_entry, sec, byte + MSDOS_FILE_WTIME_OFFSET,
@@ -572,10 +751,10 @@ msdos_set_first_cluster_num(
      * calculate input for _fat_block_write: convert (cluster num, offset) to
      * (sector num, new offset)
      */
-    sec = fat_cluster_num_to_sector_num(mt_entry, fat_fd->info_cln);
-    sec += (fat_fd->info_ofs >> fs_info->fat.vol.sec_log2);
+    sec = fat_cluster_num_to_sector_num(mt_entry, fat_fd->dir_pos.sname.cln);
+    sec += (fat_fd->dir_pos.sname.ofs >> fs_info->fat.vol.sec_log2);
     /* byte from points to start of 32bytes structure */
-    byte = fat_fd->info_ofs & (fs_info->fat.vol.bps - 1);
+    byte = fat_fd->dir_pos.sname.ofs & (fs_info->fat.vol.bps - 1);
 
     le_cl_low = CT_LE_W((uint16_t  )(new_cln & 0x0000FFFF));
     ret1 = _fat_block_write(mt_entry, sec,
@@ -615,9 +794,9 @@ msdos_set_file_size(
     uint32_t         sec = 0;
     uint32_t         byte = 0;
 
-    sec = fat_cluster_num_to_sector_num(mt_entry, fat_fd->info_cln);
-    sec += (fat_fd->info_ofs >> fs_info->fat.vol.sec_log2);
-    byte = (fat_fd->info_ofs & (fs_info->fat.vol.bps - 1));
+    sec = fat_cluster_num_to_sector_num(mt_entry, fat_fd->dir_pos.sname.cln);
+    sec += (fat_fd->dir_pos.sname.ofs >> fs_info->fat.vol.sec_log2);
+    byte = (fat_fd->dir_pos.sname.ofs & (fs_info->fat.vol.bps - 1));
 
     le_new_length = CT_LE_L((fat_fd->fat_file_size));
     ret = _fat_block_write(mt_entry, sec, byte + MSDOS_FILE_SIZE_OFFSET, 4,
@@ -650,25 +829,58 @@ msdos_set_file_size(
 int
 msdos_set_first_char4file_name(
     rtems_filesystem_mount_table_entry_t *mt_entry,
-    uint32_t                              cl,
-    uint32_t                              ofs,
+    fat_dir_pos_t                        *dir_pos,
     unsigned char                         fchar
     )
 {
-    ssize_t          ret = 0;
+    ssize_t          ret;
     msdos_fs_info_t *fs_info = mt_entry->fs_info;
-    uint32_t         sec = 0;
-    uint32_t         byte = 0;
+    uint32_t         dir_block_size;
+    fat_pos_t        start = dir_pos->lname;
+    fat_pos_t        end = dir_pos->sname;
+
+    if ((end.cln == fs_info->fat.vol.rdir_cl) &&
+        (fs_info->fat.vol.type & (FAT_FAT12 | FAT_FAT16)))
+      dir_block_size = fs_info->fat.vol.rdir_size;
+    else
+      dir_block_size = fs_info->fat.vol.bpc;
+    
+    if (dir_pos->lname.cln == FAT_FILE_SHORT_NAME)
+      start = dir_pos->sname;
 
-    sec = fat_cluster_num_to_sector_num(mt_entry, cl);
-    sec += (ofs >> fs_info->fat.vol.sec_log2);
-    byte = (ofs & (fs_info->fat.vol.bps - 1));
-
-    ret = _fat_block_write(mt_entry, sec, byte + MSDOS_FILE_NAME_OFFSET, 1,
-                           &fchar);
-    if ( ret < 0)
+    /*
+     * We handle the changes directly due the way the short file
+     * name code was written rather than use the fat_file_write
+     * interface.
+     */
+    while (true)
+    {
+      uint32_t sec = (fat_cluster_num_to_sector_num(mt_entry, start.cln) +
+                      (start.ofs >> fs_info->fat.vol.sec_log2));
+      uint32_t byte = (start.ofs & (fs_info->fat.vol.bps - 1));;
+
+      ret = _fat_block_write(mt_entry, sec, byte + MSDOS_FILE_NAME_OFFSET, 1,
+                             &fchar);
+      if (ret < 0)
         return -1;
 
+      if ((start.cln == end.cln) && (start.ofs == end.ofs))
+        break;
+
+      start.ofs += MSDOS_DIRECTORY_ENTRY_STRUCT_SIZE;
+      if (start.ofs >= dir_block_size)
+      {
+        int rc;
+        if ((end.cln == fs_info->fat.vol.rdir_cl) &&
+            (fs_info->fat.vol.type & (FAT_FAT12 | FAT_FAT16)))
+          break;
+        rc = fat_get_fat_cluster(mt_entry, start.cln, &start.cln);
+        if ( rc != RC_OK )
+          return rc;
+        start.ofs = 0;
+      }
+    }
+
     return  RC_OK;
 }
 
@@ -713,21 +925,39 @@ msdos_dir_is_empty(
              i < fs_info->fat.vol.bps;
              i += MSDOS_DIRECTORY_ENTRY_STRUCT_SIZE)
         {
-            if (((*(uint8_t *)MSDOS_DIR_NAME(fs_info->cl_buf + i)) ==
+            char* entry = (char*) fs_info->cl_buf + i;
+
+            /*
+             * If the entry is empty, a long file name entry, or '.' or '..'
+             * then consider it as empty.
+             *
+             * Just ignore long file name entries. They must have a short entry to
+             * be valid.
+             */
+            if (((*MSDOS_DIR_ENTRY_TYPE(entry)) ==
                  MSDOS_THIS_DIR_ENTRY_EMPTY) ||
-                (strncmp(MSDOS_DIR_NAME((fs_info->cl_buf + i)), MSDOS_DOT_NAME,
+                ((*MSDOS_DIR_ATTR(entry) & MSDOS_ATTR_LFN_MASK) ==
+                 MSDOS_ATTR_LFN) ||
+                (strncmp(MSDOS_DIR_NAME((entry)), MSDOS_DOT_NAME,
                          MSDOS_SHORT_NAME_LEN) == 0) ||
-                (strncmp(MSDOS_DIR_NAME((fs_info->cl_buf + i)),
+                (strncmp(MSDOS_DIR_NAME((entry)),
                          MSDOS_DOTDOT_NAME,
                          MSDOS_SHORT_NAME_LEN) == 0))
                 continue;
 
-            if ((*MSDOS_DIR_NAME(fs_info->cl_buf + i)) ==
+            /*
+             * Nothing more to look at.
+             */
+            if ((*MSDOS_DIR_NAME(entry)) ==
                 MSDOS_THIS_DIR_ENTRY_AND_REST_EMPTY)
             {
                 *ret_val = true;
                 return RC_OK;
             }
+
+            /*
+             * Short file name entries mean not empty.
+             */
             return RC_OK;
         }
         j++;
@@ -736,20 +966,15 @@ msdos_dir_is_empty(
     return RC_OK;
 }
 
-
-/* msdos_find_name_in_fat_file --
- *     This routine is used in two ways: for a new mode creation (a) or for
- *     search the node which correspondes to the 'name' parameter (b).
- *     In case (a) name should be set up to NULL and 'name_dir_entry' should
- *     point to initialized 32 bytes structure described a new node.
- *     In case (b) 'name' should contain a valid string.
- *
- *     (a): reading fat-file corresponded to directory we are going to create
- *          node in. If found free slot write contents of name_dir_entry into
- *          it.
- *
- *     (b): reading fat-file corresponded to directory and trying to find slot
- *          with the name field == name parameter
+/* msdos_create_name_in_fat_file --
+ *     This routine creates an entry in the fat file for the file name
+ *     provided by the user. The directory entry passed is the short
+ *     file name and is added as it. If the file name is long a long
+ *     file name set of entries is added.
+ *
+ *     Scan the directory for the file and if not found add the new entry.
+ *     When scanning remember the offset in the file where the directory
+ *     entry can be added.
  *
  * PARAMETERS:
  *     mt_entry       - mount table entry
